﻿/**
 * wisej.web.ext.TextBoxOpenTip
 */
qx.Class.define("wisej.web.ext.TextBoxOpenTip",
{
    extend: wisej.web.Control,

    properties: {

        /**
         * Active property.
         *
         * Enables/disables the tooltips.
         */
        active: { init: true, check: "Boolean", apply: "_applyIsActive" },
        /**
		 * Tip property.
		 */
        tooltips: { init: null, check: "Map", nullable: true, apply: "_applyOpenTipValue" },

        /**
         * Alignment property.
         *
         * Determine the position of the tooltip in relation to the opener widget.
         */
        alignment: {
            init: null,
            check: [
                "topLeft", "topCenter", "topRight",
                "bottomLeft", "bottomCenter", "bottomRight",
                "leftTop", "leftMiddle", "leftBottom",
                "rightTop", "rightMiddle", "rightBottom"
            ],
            nullable: true,
            apply: "_applyAlignment"
        },

    },

    construct: function() {

        this.base(arguments);

    },

 
    members: {
        __isActive: null,
        __alignment: null,


        _applyIsActive: function (value, old) {
            debugger;
            if (value != null)
                this.__isActive = value;
            else this.__isActive = false;

        },

        _applyAlignment: function (value, old) {
            if (value != null)
                this.__alignment = value;
            else this.__alignment = "top";
        },

        /**
		 * Creates the OpenTipValue widgets inside our widget container.
		 */
        _applyOpenTipValue: function (value, old) {

            if (old != null && old.length > 0) {
                for (var i = 0; i < old.length; i++) {
                    var comp = Wisej.Core.getComponent(old[i].id);
                    if (comp) {
                    }
                }
            }

            if (value != null && value.length > 0) {
                for (var i = 0; i < value.length; i++) {
                    var comp = Wisej.Core.getComponent(value[i].id);
                    if (comp) {
                        var myOpentip = new Opentip('#' + value[i].id, value[i].text, { style: "drop", target: true, tipJoint: "bottom", targetJoint: this.__alignment, containInViewport: false });
                    }
                }
            }
        },

    }

});